From 741df347bcae1b5dc977d777628d3d7ed70dc29c Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jul 31 2015 19:35:32 +0000
Subject: [PATCH 207/254] Meeting reminders!!


---

diff --git a/hubs/validators.py b/hubs/validators.py
index cd3d7f6..5bdf053 100644
--- a/hubs/validators.py
+++ b/hubs/validators.py
@@ -3,6 +3,9 @@ import kitchen.text.converters
 import hubs.models
 
 
+def required(session, value):
+    return bool(value)
+
 def text(session, value):
     return kitchen.text.converters.to_unicode(value)
 
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 06a3b79..d3ae5b5 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -10,6 +10,7 @@ from hubs.widgets import fedmsgstats
 from hubs.widgets import feed
 from hubs.widgets import subscriptions
 from hubs.widgets import cobwebs
+from hubs.widgets import meetings
 
 from hubs.widgets.workflow import pendingacls
 from hubs.widgets.workflow import updates2stable
@@ -29,6 +30,7 @@ registry = {
     'feed': feed,
     'subscriptions': subscriptions,
     'cobwebs': cobwebs,
+    'meetings': meetings,
 
     'workflow.pendingacls': pendingacls,
     'workflow.updates2stable': updates2stable,
diff --git a/hubs/widgets/meetings.py b/hubs/widgets/meetings.py
new file mode 100644
index 0000000..517ee92
--- /dev/null
+++ b/hubs/widgets/meetings.py
@@ -0,0 +1,74 @@
+#from hubs.hinting import hint, prefixed as _
+from hubs.widgets.base import argument
+from hubs.widgets.chrome import panel
+
+from hubs import validators
+
+import arrow
+import collections
+import datetime
+import jinja2
+import requests
+
+chrome = panel('Reminders', key='meetings')
+
+def next_meeting(meetings):
+    now = datetime.datetime.utcnow()
+    for meeting in meetings:
+        string = "%s %s" % (meeting['meeting_date'],
+                            meeting['meeting_time_start'])
+        dt = datetime.datetime.strptime(string, "%Y-%m-%d %H:%M:%S")
+
+        if now < dt:
+            meeting['human_time'] = arrow.get(dt).humanize()
+            meeting['start_date'] = dt.strftime('%b %d')
+            # Just UTC for now until we do this on the client and can access
+            # their local with moment.js.
+            meeting['start_time'] = meeting['meeting_time_start'][:-3] + " UTC"
+            meeting['location'] = meeting['meeting_location']
+            if '@' in meeting['location']:
+                meeting['location'] = '#' + meeting['location'].split('@')[0]
+            return meeting
+
+    return None
+
+jinja2_environment = jinja2.Environment()
+jinja2_environment.filters['next_meeting'] = next_meeting
+template = jinja2_environment.from_string("""
+{% if meetings %}
+    {% for title, items in meetings.items() %}
+        {% set next = items | next_meeting %}
+        {% if next %}
+        The {{ next.meeting_name }} is {{ next.human_time }}
+        <h1 class='inline'>{{next.start_date}}</h1>
+        <div class='inline'>
+            @{{next.start_time}}<br/>
+            {{next.location}}
+        </div>
+        {% endif %}
+        {% if meetings | length > 1 %}
+        <hr/>
+        {% endif %}
+    {% endfor %}
+{% endif %}
+""")
+
+
+@argument(name="calendar",
+          default=None,
+          validator=validators.required,
+          help="A fedocal calendar.")
+def data(session, widget, calendar):
+    base = 'https://apps.fedoraproject.org/calendar/api/meetings/?calendar=%s'
+    url = base % calendar
+    response = requests.get(url).json()
+
+    meetings = collections.defaultdict(list)
+    for meeting in response['meetings']:
+        meetings[meeting['meeting_name']].append(meeting)
+
+    return dict(meetings=dict(meetings))
+
+
+def should_invalidate(message, session, widget):
+    raise NotImplementedError()
diff --git a/populate.py b/populate.py
index 6cf905b..4bb1b21 100755
--- a/populate.py
+++ b/populate.py
@@ -37,7 +37,8 @@ widget = hubs.models.Widget(plugin='rules', index=1,
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='dummy', index=2)
+widget = hubs.models.Widget(plugin='meetings', index=2,
+                            _config=json.dumps({'calendar': 'i18n'}))
 hub.widgets.append(widget)
 
 # Added a hubs about widget
@@ -81,7 +82,8 @@ widget = hubs.models.Widget(plugin='rules', index=1,
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='dummy', index=2)
+widget = hubs.models.Widget(plugin='meetings', index=2,
+                            _config=json.dumps({'calendar': 'marketing'}))
 hub.widgets.append(widget)
 
 # Added a hubs about widget
@@ -128,7 +130,8 @@ widget = hubs.models.Widget(plugin='rules', index=1,
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='dummy', index=2)
+widget = hubs.models.Widget(plugin='meetings', index=2,
+                            _config=json.dumps({'calendar': 'design'}))
 hub.widgets.append(widget)
 
 # Added a hubs about widget
@@ -176,7 +179,8 @@ widget = hubs.models.Widget(plugin='rules', index=1,
                             }))
 hub.widgets.append(widget)
 
-widget = hubs.models.Widget(plugin='dummy', index=2)
+widget = hubs.models.Widget(plugin='meetings', index=2,
+                            _config=json.dumps({'calendar': 'infrastructure'}))
 hub.widgets.append(widget)
 
 # Added a hubs about widget

